import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import cm
from matplotlib.ticker import LinearLocator, FormatStrFormatter


a=3
b=5


n=2*a*b


a=3.0
b=5.0

N=2*a*b


A_inv= [[a,-a],[b,b]]

A = np.linalg.inv(A_inv)




# construct T_l

T_l=[]

plt.figure()

for i in np.arange(N):
   
    med=[i*b/N,i*a/N]
    T_l[len(T_l):] = [[np.mod(med[0],1),np.mod(med[1],1)]]


# plot T_l

for i in np.arange(len(T_l)):
    plt.plot(T_l[i][0],T_l[i][1],'ro')
plt.axis([0,1,0,1])







# construct S_r

T_r=[]
S_r=[]

plt.figure()

for i in np.arange(N):
    
    med = np.dot(A_inv,[np.mod(i/N,1),np.mod(i*(2*a+b)/N,1)])
    S_r[len(S_r):] = [[med[0]],[med[1]]]
    plt.plot(med[0],med[1],'ro')


plt.show()


sample=np.zeros(N)
sample[4]=1
fourier=np.fft.fft(sample)



# sampled function

#fine grid for plotting

delta = 1/N
sz=1
x = np.arange(0, sz, delta)
y = np.arange(0, sz, delta)

print [x[2],y[1]]
print S_r

f=np.zeros((len(x),len(y)))


print fourier[3]
#print np.exp(2*np.pi*1j*np.dot([x[2],y[5]],S_r[3]))
#
for i in np.arange(n):
    for j in np.arange(n):
        for k in np.arange(n):
            for l in np.arange(n):
                for m in np.arange(n):
            
                    f[l,m]=f[l,m]+fourier[i]*np.exp(2*np.pi*1j*np.dot(S_r[i],[x[j],y[k]]))





##
#
##evaluate Dirichlet kernel at grid

D=np.zeros((len(x),len(y)))+1j*np.zeros((len(x),len(y)))
pt=5


for i in range(len(x)):
    for j in range(len(y)):
        for k in range(len(index)):
            D[i,j]=D[i,j]+index[k][2]*np.exp(1j*np.dot([index[k][0],index[k][1]],[x[i]-lat[pt][0],y[j]-lat[pt][1]]))+\
            +index[k][2]*np.exp(1j*np.dot([index[k][0],index[k][1]],[x[i]-lat[pt][0],y[j]+lat[pt][1]]))+\
            +index[k][2]*np.exp(1j*np.dot([index[k][0],index[k][1]],[x[i]+lat[pt][0],y[j]-lat[pt][1]]))+\
            +index[k][2]*np.exp(1j*np.dot([index[k][0],index[k][1]],[x[i]+lat[pt][0],y[j]+lat[pt][1]]))



# evaluate Dirichlet kernel at lattice points

D=np.zeros((len(lat)))+1j*np.zeros((len(lat)))

for i in range(len(lat)):
    for k in range(len(index)):
        D[i]=D[i]+index[k][2]*np.exp(1j*2*np.pi*np.dot([index[k][0],index[k][1]],lat[i]))

for i in np.arange(len(index)):

    print D[i], index[i], lat[i]


#plot polynomial lagrange
#
plt.figure()
CS = plt.contour(np.cos(X), np.cos(Y), D.real)
#CS = plt.contour(X, Y, D.real)
plt.clabel(CS, inline=1, fontsize=10)

for i in np.arange(len(lat)):
    plt.plot(np.cos(lat[i][0]),np.cos(lat[i][1]),'ro')
plt.axis([-1,1,-1,1])

plt.show()

#plot trigonometric lagrange

#plt.figure()
#CS = plt.contour(X, Y, D.real)
##CS = plt.contour(X, Y, D.real)
#plt.clabel(CS, inline=1, fontsize=10)
#
#



fig = plt.figure()
ax = fig.gca(projection='3d')
surf = ax.plot_surface(np.cos(X), np.cos(Y), D.real, rstride=1, cstride=1, cmap=cm.coolwarm,linewidth=0, antialiased=False)
ax.set_zlim(-100, 100)
ax.zaxis.set_major_locator(LinearLocator(10))
ax.zaxis.set_major_formatter(FormatStrFormatter('%.02f'))

fig.colorbar(surf, shrink=0.5, aspect=5)


plt.show()


