import numpy as np
import matplotlib.pyplot as plt

metode=2 #1=eksplisitt euler, 2=symplektisk euler, 3=implisitt euler, 4=trapesmetoden

n=200.0
h=4*np.pi/n

x=np.zeros(int(n))
y=np.zeros(int(n))

x[0]=1
y[0]=1

#eksplisitt euler
if metode==1:
    for i in range(int(n-1)):
        x[i+1]=x[i]-h*y[i]
        y[i+1]=y[i]+h*x[i]



#symplektisk euler
if metode==2:
    for i in range(int(n-1)):
        x[i+1]=x[i]-h*y[i]
        y[i+1]=y[i]+h*x[i+1]


#implisitt euler
if metode==3:
    A=np.array([[1, h],[-h, 1]])
    v=np.array([x[0], y[0]])
    for i in range(int(n-1)):
        v=np.linalg.solve(A,v)
        x[i+1]=v(1)
        y[i+1]=v(2)



#trapesmetoden
if metode==4:
    A=np.array([[1, h],[-h, 1]])
    v=np.array([x[0], y[0]])
    for i in range(int(n-1)):
        v=[x[i]-h*y[i],y[i]+h*x[i]]
        v=np.linalg.solve(A,v)
        x[i+1]=v[1]
        y[i+1]=v[2]



plt.plot(x,y)
plt.savefig('oving_12_1_anbefalt')
